#ifndef NULLSOFT_API_PLAYLISTLOADERCALLBACK_H
#define NULLSOFT_API_PLAYLISTLOADERCALLBACK_H

#include <bfc/dispatch.h>
#include <bfc/platform/types.h>
#include "../playlist/api_plentryinfo.h"

class api_playlistinfo; // TODO
class api_playlistloadercallback : public Dispatchable
{
protected:
	api_playlistloadercallback() {}
	~api_playlistloadercallback() {}
public:
	// title will be NULL if no title found, length will be -1
	void OnFile(const wchar_t *filename, const wchar_t *title, int lengthInMS, api_plentryinfo *info); 
  // numEntries is just a hint, there is no gaurantee.  0 means "don't know"
  void OnPlaylistInfo(const wchar_t *playlistName, size_t numEntries, api_playlistinfo *info); 
  const wchar_t *GetBasePath(); // return 0 to use playlist file path as base (or just don't implement)

	DISPATCH_CODES
	{
		API_PLAYLISTLOADERCALLBACK_ONFILE = 10,
			API_PLAYLISTLOADERCALLBACK_ONPLAYLISTINFO = 20,
			API_PLAYLISTLOADERCALLBACK_GETBASEPATH = 30,
	};
};

inline void api_playlistloadercallback::OnFile(const wchar_t *filename, const wchar_t *title, int lengthInMS, api_plentryinfo *info)
{
	_voidcall(API_PLAYLISTLOADERCALLBACK_ONFILE, filename, title, lengthInMS, info);
}

inline const wchar_t *api_playlistloadercallback::GetBasePath()
{
return _call(API_PLAYLISTLOADERCALLBACK_GETBASEPATH, (const wchar_t *)0);
}

#endif