// SettingsDialogMouseClicks.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"   	// main symbols
#include "SysTrayPlay.h"
#include "SettingsDialogMouseClicks.h"
#include "MainHelper.h"
#include "MainWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Bote de dialogue CSettingsDialogMouseClicks

IMPLEMENT_MENUXP(CSettingsDialogMouseClicks, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogMouseClicks, CPropertyPage)
CSettingsDialogMouseClicks::CSettingsDialogMouseClicks() : CPropertyPage(CSettingsDialogMouseClicks::IDD)
{
	m_noclicks = FALSE;
}

CSettingsDialogMouseClicks::~CSettingsDialogMouseClicks()
{
}

bool CSettingsDialogMouseClicks::CheckClicks()
{
	if (m_iclicks1 == IDS_CLICKS10 - IDS_CLICKS0 || m_iclicks2 == IDS_CLICKS10 - IDS_CLICKS0 || m_iclicks3 == IDS_CLICKS10 - IDS_CLICKS0 || m_iclicks4 == IDS_CLICKS10 - IDS_CLICKS0 || m_iclicksr1 == IDS_CLICKS10 - IDS_CLICKS0 || m_iclicksr2 == IDS_CLICKS10 - IDS_CLICKS0 || m_iclicksr3 == IDS_CLICKS10 - IDS_CLICKS0 || m_iclicksr4 == IDS_CLICKS10 - IDS_CLICKS0)
		return true;

	return false;
}

void CSettingsDialogMouseClicks::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	DDX_Control(pDX, IDC_CLICKSR4, m_clicksr4);
	DDX_Control(pDX, IDC_CLICKSR3, m_clicksr3);
	DDX_Control(pDX, IDC_CLICKSR2, m_clicksr2);
	DDX_Control(pDX, IDC_CLICKSR1, m_clicksr1);
	DDX_Control(pDX, IDC_CLICKS4, m_clicks4);
	DDX_Control(pDX, IDC_CLICKS3, m_clicks3);
	DDX_Control(pDX, IDC_CLICKS2, m_clicks2);
	DDX_Control(pDX, IDC_CLICKS1, m_clicks1);
	DDX_Check(pDX, IDC_NOCLICKS, m_noclicks);

	DDX_CBIndex(pDX, IDC_CLICKSR4, m_iclicksr4);
	DDX_CBIndex(pDX, IDC_CLICKSR3, m_iclicksr3);
	DDX_CBIndex(pDX, IDC_CLICKSR2, m_iclicksr2);
	DDX_CBIndex(pDX, IDC_CLICKSR1, m_iclicksr1);
	DDX_CBIndex(pDX, IDC_CLICKS4, m_iclicks4);
	DDX_CBIndex(pDX, IDC_CLICKS3, m_iclicks3);
	DDX_CBIndex(pDX, IDC_CLICKS2, m_iclicks2);
	DDX_CBIndex(pDX, IDC_CLICKS1, m_iclicks1);

	DDX_Check(pDX, IDC_NOCLICKS, m_noclicks);
	DDX_Control(pDX, IDC_PANDH, m_pandh);
}

void CSettingsDialogMouseClicks::FillClicksPopup(CComboBox* cb, int clicks)
{
	cb->AddString(m_Helper.MyLoadString(IDS_CLICKS0));
	cb->AddString(m_Helper.MyLoadString(IDS_CLICKS1));
	cb->AddString(m_Helper.MyLoadString(IDS_CLICKS2));
	cb->AddString(m_Helper.MyLoadString(IDS_CLICKS3));
	cb->AddString(m_Helper.MyLoadString(IDS_CLICKS4));
	cb->AddString(m_Helper.MyLoadString(IDS_CLICKS5));
	cb->AddString(m_Helper.MyLoadString(IDS_CLICKS6));
	cb->AddString(m_Helper.MyLoadString(IDS_CLICKS7));
	cb->AddString(m_Helper.MyLoadString(IDS_CLICKS8));
	cb->AddString(m_Helper.MyLoadString(IDS_CLICKS9));
	cb->AddString(m_Helper.MyLoadString(IDS_CLICKS10));
	cb->AddString(m_Helper.MyLoadString(IDS_CLICKS11));

	cb->SetCurSel(clicks);
}

BOOL CSettingsDialogMouseClicks::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	m_Helper.translateDlgItemText(this, IDC_LPRESSHOLD);
	m_Helper.translateDlgItemText(this, IDC_NOCLICKS);
	m_Helper.translateDlgItemText(this, IDC_LG1);
	m_Helper.translateDlgItemText(this, IDC_LG2);
	m_Helper.translateDlgItemText(this, IDC_LG3);
	m_Helper.translateDlgItemText(this, IDC_LG4);
	m_Helper.translateDlgItemText(this, IDC_LR1);
	m_Helper.translateDlgItemText(this, IDC_LR2);
	m_Helper.translateDlgItemText(this, IDC_LR3);
	m_Helper.translateDlgItemText(this, IDC_LR4);

	FillClicksPopup(&m_clicks1, pMainFrame->Clicks1);
	FillClicksPopup(&m_clicks2, pMainFrame->Clicks2);
	FillClicksPopup(&m_clicks3, pMainFrame->Clicks3);
	FillClicksPopup(&m_clicks4, pMainFrame->Clicks4);

	FillClicksPopup(&m_clicksr1, pMainFrame->RClicks1);
	FillClicksPopup(&m_clicksr2, pMainFrame->RClicks2);
	FillClicksPopup(&m_clicksr3, pMainFrame->RClicks3);
	FillClicksPopup(&m_clicksr4, pMainFrame->RClicks4);

	m_clicks1.EnableWindow(!m_noclicks);
	m_clicks2.EnableWindow(!m_noclicks);
	m_clicks3.EnableWindow(!m_noclicks);
	m_clicks4.EnableWindow(!m_noclicks);
	m_clicksr1.EnableWindow(!m_noclicks);
	m_clicksr2.EnableWindow(!m_noclicks);
	m_clicksr3.EnableWindow(!m_noclicks);
	m_clicksr4.EnableWindow(!m_noclicks);

	m_pandh.AddString(m_Helper.MyLoadString(IDS_PANDH1));
	m_pandh.AddString(m_Helper.MyLoadString(IDS_PANDH2));
	m_pandh.AddString(m_Helper.MyLoadString(IDS_PANDH3));

	m_noclicks = (pMainFrame->NoClicks == 1);

	switch (pMainFrame->PressAndHold)
	{
	case 2:
		m_pandh.SetCurSel(0);
		break;
	case 0:
		m_pandh.SetCurSel(1);
		break;
	case 1:
		m_pandh.SetCurSel(2);
		break;
	}

	m_pandh.EnableWindow(!m_noclicks);
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsDialogMouseClicks::OnOK()
{
	UpdateData(TRUE);
	if (!CheckClicks())
	{
		MessageBox(m_Helper.MyLoadString(IDS_WRONGCLICKS), _T("STP"), MB_OK | MB_ICONERROR);
		CPropertyPage::OnCancel();
		return;
	}

	switch (m_pandh.GetCurSel())
	{
	case 0:
		pMainFrame->PressAndHold = 2;
		break;
	case 1:
		pMainFrame->PressAndHold = 0;
		break;
	case 2:
		pMainFrame->PressAndHold = 1;
		break;
	}
	pMainFrame->NoClicks = m_noclicks ? 1 : 0;

	pMainFrame->Clicks1 = m_iclicks1;
	pMainFrame->Clicks2 = m_iclicks2;
	pMainFrame->Clicks3 = m_iclicks3;
	pMainFrame->Clicks4 = m_iclicks4;
	pMainFrame->RClicks1 = m_iclicksr1;
	pMainFrame->RClicks2 = m_iclicksr2;
	pMainFrame->RClicks3 = m_iclicksr3;
	pMainFrame->RClicks4 = m_iclicksr4;

	CPropertyPage::OnOK();
}

void CSettingsDialogMouseClicks::OnNoClicks()
{
	bool check = ((CButton*)GetDlgItem(IDC_NOCLICKS))->GetCheck() == 1;
	m_clicks1.EnableWindow(!check);
	m_clicks2.EnableWindow(!check);
	m_clicks3.EnableWindow(!check);
	m_clicks4.EnableWindow(!check);
	m_clicksr1.EnableWindow(!check);
	m_clicksr2.EnableWindow(!check);
	m_clicksr3.EnableWindow(!check);
	m_clicksr4.EnableWindow(!check);
	m_pandh.EnableWindow(!check);
}
BEGIN_MESSAGE_MAP(CSettingsDialogMouseClicks, CPropertyPage)
	ON_BN_CLICKED(IDC_NOCLICKS, OnNoClicks)
	ON_MENUXP_MESSAGES()
END_MESSAGE_MAP()


// Gestionnaires de messages CSettingsDialogMouseClicks
