#include "stdafx.h"
#include "resource.h"
#include "vidout.h"
#include "convert.h"
#include "Tools/filters.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int infoWidth;
int infoHeight;
CString infoTitle;

BEGIN_MESSAGE_MAP(CVidOut, CDialog)
	ON_WM_SIZE()
	ON_WM_SHOWWINDOW()
	ON_WM_PAINT()
END_MESSAGE_MAP()

CVidOut::CVidOut() : CDialog(CVidOut::IDD)
{
	donnees = NULL;
	m_bmpinfo = NULL;
	CanResize = false;
	width = 100;
	height = 100;
}
CVidOut::~CVidOut()
{
	if (m_bmpinfo != NULL)
	{
		delete m_bmpinfo;
		m_bmpinfo = NULL;
	}
	if (this->m_hWnd != NULL)
		this->DestroyWindow();
	if (donnees != NULL)
	{
		delete donnees;
		donnees = NULL;
	}
}

void CVidOut::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BOOL CVidOut::OnInitDialog()
{
	CDialog::OnInitDialog();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVidOut::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);
	CanResize = bShow ? true : false;
}
void CVidOut::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);
	if (CanResize)
	{
		CRect rectangle;
		GetWindowRect(&rectangle);
		//		if(rectangle.Width()>width)
		//			rectangle.right = rectangle.left + width;
		//		if(rectangle.Height()>height)
		//			rectangle.bottom = rectangle.top + height;

		this->SetWindowPos(NULL, 0, 0, rectangle.Width(), rectangle.Height(), SWP_NOMOVE | SWP_NOZORDER);
		Draw();
	}
}

void CVidOut::OnPaint()
{
	CDialog::OnPaint();
	CDC* dc = GetDC();

	CRect rectangle, rectangle1, rectangle2;
	GetClientRect(&rectangle);
	ClientToScreen(&rectangle);

	rectangle1.top = rectangle.top;
	rectangle1.left = rectangle.left;
	rectangle1.bottom = rectangle.top + rectangle.Height();
	rectangle1.right = rectangle.left + rectangle.Height() * width / height;

	rectangle2.top = rectangle.top;
	rectangle2.left = rectangle.left;
	rectangle2.bottom = rectangle.top + rectangle.Width() * height / width;
	rectangle2.right = rectangle.left + rectangle.Width();

	COLORREF cColor = RGB(0, 0, 0);
	if (rectangle1.Width() < rectangle.Width())
	{
		rectangle1.OffsetRect((rectangle.Width() - rectangle1.Width()) / 2, 0);
		CRect noirGauche, noirDroite;
		noirGauche.top = rectangle.top;
		noirGauche.bottom = rectangle.bottom;
		noirGauche.left = rectangle.left;
		noirGauche.right = rectangle1.left;
		ScreenToClient(&noirGauche);
		dc->FillSolidRect(noirGauche.left, noirGauche.top, noirGauche.Width(), noirGauche.Height(), cColor);

		noirDroite.top = rectangle.top;
		noirDroite.bottom = rectangle.bottom;
		noirDroite.left = rectangle1.right;
		noirDroite.right = rectangle.right;
		ScreenToClient(&noirDroite);
		dc->FillSolidRect(noirDroite.left, noirDroite.top, noirDroite.Width(), noirDroite.Height(), cColor);
	}
	else
	{
		rectangle2.OffsetRect(0, (rectangle.Height() - rectangle2.Height()) / 2);
		CRect noirGauche, noirDroite;
		noirGauche.top = rectangle.top;
		noirGauche.bottom = rectangle2.top;
		noirGauche.left = rectangle.left;
		noirGauche.right = rectangle.right;
		ScreenToClient(&noirGauche);
		dc->FillSolidRect(noirGauche.left, noirGauche.top, noirGauche.Width(), noirGauche.Height(), cColor);

		noirDroite.top = rectangle2.bottom;
		noirDroite.bottom = rectangle.bottom;
		noirDroite.left = rectangle.left;
		noirDroite.right = rectangle.right;
		ScreenToClient(&noirDroite);
		dc->FillSolidRect(noirDroite.left, noirDroite.top, noirDroite.Width(), noirDroite.Height(), cColor);
	}
	Draw();
}

__forceinline void CVidOut::Draw()
{
	if (width > 10)
	{
		CRect rectangle, rectangle1, rectangle2;
		GetClientRect(&rectangle);
		ClientToScreen(&rectangle);

		rectangle1.top = rectangle.top;
		rectangle1.left = rectangle.left;
		rectangle1.bottom = rectangle.top + rectangle.Height();
		rectangle1.right = rectangle.left + rectangle.Height() * width / height;

		rectangle2.top = rectangle.top;
		rectangle2.left = rectangle.left;
		rectangle2.bottom = rectangle.top + rectangle.Width() * height / width;
		rectangle2.right = rectangle.left + rectangle.Width();
		if (rectangle1.Width() < rectangle.Width())
		{
			rectangle1.OffsetRect((rectangle.Width() - rectangle1.Width()) / 2, 0);
			ScreenToClient(&rectangle1);
			SetStretchBltMode(this->GetDC()->m_hDC, HALFTONE);
			StretchDIBits(this->GetDC()->m_hDC, rectangle1.left, rectangle1.top, rectangle1.Width(), rectangle1.Height(), 0, 0, width, height, donnees, (LPBITMAPINFO)&m_bmpinfo->bmiHeader, DIB_RGB_COLORS, SRCCOPY);
		}
		else
		{
			rectangle2.OffsetRect(0, (rectangle.Height() - rectangle2.Height()) / 2);

			ScreenToClient(&rectangle2);
			SetStretchBltMode(this->GetDC()->m_hDC, HALFTONE);
			StretchDIBits(this->GetDC()->m_hDC, rectangle2.left, rectangle2.top, rectangle2.Width(), rectangle2.Height(), 0, 0, width, height, donnees, (LPBITMAPINFO)&m_bmpinfo->bmiHeader, DIB_RGB_COLORS, SRCCOPY);
		}
	}
}

CIVideoOutput::CIVideoOutput()
{
	InitConvertTable();

	RGB_Scale = 0x1000254310002543;
	RGB_Offset = 0x0010001000100010;
	RGB_CBU = 0x0000428500004285;
	RGB_CGX = 0xF7BFEEA3F7BFEEA3;
	RGB_CRV = 0x0000396900003969;
	InitializeFilter();
}
CIVideoOutput::~CIVideoOutput()
{
}

void CIVideoOutput::SetVidOut(CVidOut* pvidOut)
{
	vidOut = pvidOut;
}

int CIVideoOutput::open(int w, int h, int vflip, double aspectratio, unsigned int fmt)
{
	char ch[5];
	ch[0] = (char)(fmt & 0xFF);
	ch[1] = (char)(fmt >> 8 & 0xFF);
	ch[2] = (char)(fmt >> 16 & 0xFF);
	ch[3] = (char)(fmt >> 24 & 0xFF);
	ch[4] = 0;
	TRACE(_T("open %d %d %d %f %d %s\n"), w, h, vflip, aspectratio, fmt, ch);
	width = w;
	height = h;
	vidOut->width = w;
	vidOut->height = h;
	infoWidth = w;
	infoHeight = h;

	Coded_Picture_Width = w;
	Coded_Picture_Height = h;

	Clip_Width = w;
	Clip_Height = h;

	CLIP_AREA = HALF_CLIP_AREA = CLIP_STEP = CLIP_HALF_STEP = 0;

	NINE_CLIP_WIDTH = Clip_Width * 9;
	QUAD_CLIP_WIDTH = Clip_Width << 2;
	DOUBLE_CLIP_WIDTH = Clip_Width << 1;
	HALF_CLIP_WIDTH = Clip_Width >> 1;

	LUM_AREA = Coded_Picture_Width * Clip_Height;
	DOUBLE_WIDTH = Coded_Picture_Width << 1;
	HALF_WIDTH = Coded_Picture_Width >> 1;
	HALF_WIDTH_D8 = (Coded_Picture_Width >> 1) - 8;
	PROGRESSIVE_HEIGHT = (Coded_Picture_Height >> 1) - 2;
	INTERLACED_HEIGHT = (Coded_Picture_Height >> 2) - 2;
	RGB_DOWN1 = Clip_Width * (Clip_Height - 1) * 3;
	RGB_DOWN2 = Clip_Width * (Clip_Height - 2) * 3;


	if (vidOut->m_bmpinfo != NULL)
	{
		delete vidOut->m_bmpinfo;
		vidOut->m_bmpinfo = NULL;
	}
	vidOut->m_bmpinfo = new BITMAPINFO;
	vidOut->m_bmpinfo->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	vidOut->m_bmpinfo->bmiHeader.biWidth = width;
	vidOut->m_bmpinfo->bmiHeader.biHeight = height;
	vidOut->m_bmpinfo->bmiHeader.biPlanes = 1;
	vidOut->m_bmpinfo->bmiHeader.biBitCount = 24;
	vidOut->m_bmpinfo->bmiHeader.biCompression = BI_RGB;
	vidOut->m_bmpinfo->bmiHeader.biSizeImage = 0;
	vidOut->m_bmpinfo->bmiHeader.biXPelsPerMeter = 0;
	vidOut->m_bmpinfo->bmiHeader.biYPelsPerMeter = 0;
	vidOut->m_bmpinfo->bmiHeader.biClrUsed = 0;
	vidOut->m_bmpinfo->bmiHeader.biClrImportant = 0;

	if (vidOut->donnees != NULL)
	{
		delete vidOut->donnees;
		vidOut->donnees = NULL;
	}
	vidOut->donnees = (unsigned char*)calloc(3 * width * height, sizeof(unsigned char*));

	return 0;
}
void CIVideoOutput::setcallback(LRESULT(*msgcallback)(void* token, HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam), void* token)
{
	TRACE(_T("setcallback\n"));
}

void CIVideoOutput::close()
{
	TRACE(_T("close\n"));
}

void CIVideoOutput::draw(void* frame)
{
	TRACE(_T("draw\n"));
	BYTE* pdon;
	YV12_PLANES* fr = (YV12_PLANES*)frame;
	pdon = vidOut->donnees;

	//ConvertYUV4202RGB(fr->y.baseAddr, fr->u.baseAddr, fr->v.baseAddr, pdon, width, height);

	unsigned char* uu, * vv, * uu2, * vv2;
	uu = new unsigned char[width * height];
	vv = new unsigned char[width * height];
	uu2 = new unsigned char[width * height];
	vv2 = new unsigned char[width * height];

	conv420to422(fr->u.baseAddr, uu, true);
	conv420to422(fr->v.baseAddr, vv, true);
	conv422to444(uu, uu2);
	conv422to444(vv, vv2);
	conv444toRGB24odd(fr->y.baseAddr, uu2, vv2, pdon);
	conv444toRGB24even(fr->y.baseAddr, uu2, vv2, pdon);

	//	ConvertYUV4202YUV422(fr->u.baseAddr, fr->v.baseAddr, uu, vv, width, height);
	//	ConvertYUV4222YUV444(uu, vv, uu2, vv2, width, height);
	//	ConvertYUV4442RGB(fr->y.baseAddr, uu2, vv2, pdon, width, height);

	delete uu;
	delete vv;
	delete uu2;
	delete vv2;
	vidOut->Draw();
}

void CIVideoOutput::drawSubtitle(SubsItem* item)
{
	TRACE(_T("drawSubtitle\n"));
}

void CIVideoOutput::showStatusMsg(const char* text)
{
	TRACE(_T("showStatusMsg %s\n"), text);
}

int CIVideoOutput::get_latency()
{
	TRACE(_T("get_latency\n"));
	return 0;
}

void CIVideoOutput::notifyBufferState(int bufferstate)
{
	TRACE(_T("notifyBufferState %d\n"), bufferstate);
} /* 0-255*/

int CIVideoOutput::extended(int param1, int param2, int param3)
{
	switch (param1)
	{
	case VIDUSER_SET_INFOSTRING:
		TRACE(_T("extended VIDUSER_SET_INFOSTRING %s %d\n"), (char*)param2, param3);
		infoTitle.Format(_T("%s"), (char*)param2);
		break;
	case VIDUSER_GET_VIDEOHWND:
		TRACE(_T("extended VIDUSER_GET_VIDEOHWND %d %d\n"), param2, param3);
		break;
	case VIDUSER_SET_VFLIP:
		TRACE(_T("extended VIDUSER_SET_VFLIP %d %d\n"), param2, param3);
		break;
	case VIDUSER_SET_TRACKSELINTERFACE:
		TRACE(_T("extended VIDUSER_SET_TRACKSELINTERFACE %d %d\n"), param2, param3);
		break;
	}
	return 0;
} //Dispatchable, eat this!
